-- set up the environment for the bind variable peek example
-- J.Nemec 2006
-- http://www.db-nemec.com
-- 
-- this script generate execution plans for different scenarios discussed in the paper
--
-- generate plan for year 2005 
-- using the partition level statistics of the 2005 partition
--
EXPLAIN PLAN set statement_id = 'N1' into plan_table  
    FOR
update my_fact a
set status = 'D'
where entity_id = 4 and business_year = TO_DATE('2005-01-01','YYYY-MM-DD')
and version = (select max(version) from my_fact b 
               where a.entity_id = b.entity_id and 
			        a.business_year = b.business_year);
---
SELECT * FROM table(DBMS_XPLAN.DISPLAY('plan_table', 'N1','ALL')) ;
---
-- generate plan for year 2006 
-- using the partition level statistics of the 2006 partition
--
EXPLAIN PLAN set statement_id = 'N2' into plan_table  
    FOR
update my_fact a
set status = 'D'
where entity_id = 4 and business_year = TO_DATE('2006-01-01','YYYY-MM-DD')
and version = (select max(version) from my_fact b 
               where a.entity_id = b.entity_id and 
			         a.business_year = b.business_year);
---
SELECT * FROM table(DBMS_XPLAN.DISPLAY('plan_table', 'N2','ALL')) ;
---
-- generate plan using bind variables
EXPLAIN PLAN set statement_id = 'N1' into plan_table  
    FOR
update my_fact a
set status = 'D'
where entity_id = :1 and business_year = :2
and version = (select max(version) from my_fact b 
               where a.entity_id = b.entity_id and a.business_year = b.business_year);
---
SELECT * FROM table(DBMS_XPLAN.DISPLAY('plan_table', 'N1','ALL')) ;
--- 

